BasicSplitPaneDivider.DragController (Java SE 26 & JDK 26)
Description: declaration: module: java.desktop, package: javax.swing.plaf.basic, class: BasicSplitPaneDivider, class: DragController
Keywords: javax.swing.plaf.basic.BasicSplitPaneDivider.DragController class

# Class BasicSplitPaneDivider.DragController

java.lang.Object
javax.swing.plaf.basic.BasicSplitPaneDivider.DragController

Direct Known Subclasses:
  `BasicSplitPaneDivider.VerticalDragController`

Enclosing class:
  `BasicSplitPaneDivider`

protected class BasicSplitPaneDivider.DragController extends Object
Handles the events during a dragging session for a HORIZONTAL_SPLIT oriented split pane. This continually messages `dragDividerTo` and then when done messages `finishDraggingTo`. When an instance is created it should be messaged with `isValid` to insure that dragging can happen (dragging won't be allowed if the two views can not be resized).

Warning: Serialized objects of this class will not be compatible with future Swing releases. The current serialization support is appropriate for short term storage or RMI between applications running the same version of Swing. As of 1.4, support for long term storage of all JavaBeans has been added to the `java.beans` package. Please see `XMLEncoder`.

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `DragController(MouseEvent e)`
  Constructs a new instance of `DragController`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected void`
  `completeDrag(int x, int y)`
  Messages finishDraggingTo with the new location for the mouse event.
  `protected void`
  `completeDrag(MouseEvent e)`
  Messages finishDraggingTo with the new location for the mouse event.
  `protected void`
  `continueDrag(int newX, int newY)`
  Messages dragDividerTo with the new location for the mouse event.
  `protected void`
  `continueDrag(MouseEvent e)`
  Messages dragDividerTo with the new location for the mouse event.
  `protected int`
  `getNeededLocation(int x, int y)`
  Returns the x argument, since this is used for horizontal splits.
  `protected boolean`
  `isValid()`
  Returns `true` if the dragging session is valid.
  `protected int`
  `positionForMouseEvent(MouseEvent e)`
  Returns the new position to put the divider at based on the passed in MouseEvent.

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`
  Modifier and Type
  Method
  Description
  `protected Object`
  `clone()`
  Creates and returns a copy of this object.
  `boolean`
  `equals(Object obj)`
  Indicates whether some other object is "equal to" this one.
  `protected void`
  `finalize()`
  Deprecated, for removal: This API element is subject to removal in a future version.
  Finalization is deprecated and subject to removal in a future release.
  `final Class<?>`
  `getClass()`
  Returns the runtime class of this `Object`.
  `int`
  `hashCode()`
  Returns a hash code value for this object.
  `final void`
  `notify()`
  Wakes up a single thread that is waiting on this object's monitor.
  `final void`
  `notifyAll()`
  Wakes up all threads that are waiting on this object's monitor.
  `String`
  `toString()`
  Returns a string representation of the object.
  `final void`
  `wait()`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
  `final void`
  `wait(long timeoutMillis)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
  `final void`
  `wait(long timeoutMillis, int nanos)`
  Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

- ## Constructor Details

  - ### DragController

    protected DragController(MouseEvent e)
    Constructs a new instance of `DragController`.
    Parameters:
      `e` - a mouse event

- ## Method Details

  - ### isValid

    protected boolean isValid()
    Returns `true` if the dragging session is valid.
    Returns:
      `true` if the dragging session is valid

  - ### positionForMouseEvent

    protected int positionForMouseEvent(MouseEvent e)
    Returns the new position to put the divider at based on the passed in MouseEvent.
    Parameters:
      `e` - a mouse event
    Returns:
      the new position

  - ### getNeededLocation

    protected int getNeededLocation(int x, int y)
    Returns the x argument, since this is used for horizontal splits.
    Parameters:
      `x` - an X coordinate
      `y` - an Y coordinate
    Returns:
      the X argument

  - ### continueDrag

    protected void continueDrag(int newX, int newY)
    Messages dragDividerTo with the new location for the mouse event.
    Parameters:
      `newX` - an X coordinate
      `newY` - an Y coordinate

  - ### continueDrag

    protected void continueDrag(MouseEvent e)
    Messages dragDividerTo with the new location for the mouse event.
    Parameters:
      `e` - a mouse event

  - ### completeDrag

    protected void completeDrag(int x, int y)
    Messages finishDraggingTo with the new location for the mouse event.
    Parameters:
      `x` - an X coordinate
      `y` - an Y coordinate

  - ### completeDrag

    protected void completeDrag(MouseEvent e)
    Messages finishDraggingTo with the new location for the mouse event.
    Parameters:
      `e` - a mouse event